/**
 * Main controller class for Dots game.
 */
package controller;

import java.awt.event.*;
import model.*;
import view.*;
/**
 * @author dennis
 *
 */
public class DotsMain {

	/**
	 * @param args
	 */
	public static void main(String[] args) {
		try {
			DotsModelInterface game = new model.dpeters.DotsModel();
			DotsFrame view = new DotsFrame(game);
			ViewCloseListener vlc = new ViewCloseListener();
		    view.addWindowListener(vlc);
			// TODO: Add logging
			while (!view.uiIsReady()) Thread.sleep(500);
		    game.setObserver(view);
		    while (vlc.uiExists) {
		    	Thread.sleep(500);
		    }

		}
		catch (Exception e) {
			System.out.println("Exception: " + e);
		}
	}
	

}

/**
 * Class to listen for the view closing.
 *
 */
class ViewCloseListener
  extends WindowAdapter
{
  public ViewCloseListener()
  {
    uiExists = true;
  }

  public void windowClosed(WindowEvent e) 
  {
    uiExists = false;
  }

  /** Set to false when the UI is closed */
  protected boolean uiExists;
}
