/**
 * BoardController.java
 * @author dennis
 * Created: Jan 22, 2006
 */
package view;

import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import model.DotsModelInterface;

/**
 * @author dennis
 *
 */
class BoardController extends MouseAdapter {
	/**
	 * @param frame frame for this controller's view
	 * @param board view for this controller
	 * @param game mode of the game
	 */
	public BoardController(DotsFrame frame, BoardView board, DotsModelInterface game) {
		mFrame = frame;
		mGame = game;
		mBoard = board;
		mFrame.setStatus("Initializing");		
	}
	
	public void mouseClicked(MouseEvent e) {
		if (e.getButton() == MouseEvent.BUTTON1) {
			int row;
			int col;
			if ((row = mBoard.getRowOrCol(e.getY())) != -1) {
				if ((col = mBoard.getRowOrColBetween(e.getX())) != -1 && 
						col < mGame.getCols()-1) {
					mGame.addHorizontalSegment(row, col);
				}
			} else if ((col = mBoard.getRowOrCol(e.getX())) != -1) {
				if ((row = mBoard.getRowOrColBetween(e.getY())) != -1 && 
						row < mGame.getRows()-1) {
					mGame.addVerticalSegment(row, col);
				}	
			}
		}
	}
	
	/** Model for the game */
	private DotsModelInterface mGame;
	
	/** View that this is controlling */
	private BoardView mBoard;
	
	/** Frame for this view (for status and score fields) */
	private DotsFrame mFrame;
}
